
import tichy.gui as gui
from tichy.menu import Menu
from tichy.list import List
from tichy.style import Style, Font, Frame, Tag

class Style2(Style):
    name = "black style"
        
    @classmethod
    def code(cls):
        return {
            'background' : None,
            'font' : Font(Style2.path('font.ttf'), 24),
            gui.Edit : {'background' : Frame(gui.Image(Style2.path('edit_frame.png')))},
            gui.Button : {'background' : Frame(gui.Image(Style2.path('button_frame.png')))},
            # The tag here is a filter on the widgets that have this string in there keys
            Tag('application-bar') : {
                'background' : Frame(gui.Image(Style2.path('bar_frame.png'))),
                'children-style' : {
                    'background': None,
                    Tag('back-button') : {'background' : Frame(gui.Image(Style2.path('button_frame.png')))},
                }
            },
            Tag('application-content') : {'background' : Frame(gui.Image(Style2.path('content_frame.png')))},
            
            'pressed-style' : {'background' : Frame(gui.Image(Style2.path('button_pressed_frame.png')))},
            'selected-style' : {'background' : Frame(gui.Image(Style2.path('button_pressed_frame.png')))},
            
            Menu : {
                'children-style' : {
                    gui.Button : {'background' : Frame(gui.Image(Style2.path('menu_button_frame.png')))},
                }
            },
            
            List : {
                'children-style' : {
                    gui.Button : {'background' : Frame(gui.Image(Style2.path('list_button_frame.png')))},
                }
            },
            
            gui.ScrollableSlide : {'background' : Frame(gui.Image(Style2.path('button_frame.png')))},
        }
