
from tichy.service import Service, ServiceUnusable
from tichy.object import Object

import tichy
import tichy.gui as gui

from tichy.phone import TelNumber

class Contact(dict, tichy.Item):
    def __init__(self, name):
        self.name = name
        super(Contact, self).__init__()
        self['name'] = name
    def view(self, parent, editable = True):
        return gui.Label(parent, self.name)

class ContactsService(dict, Service):
    service = 'Contacts'
        
    def __init__(self):
        fabien = self.create('Fabien')
        fabien['tel'] = TelNumber('0478657392')
        fabien['note'] = tichy.Text('hello')
        
        etienne = self.create('Etienne')
        etienne['tel'] = TelNumber('044569892')
        
        for i in range(5):
            c = self.create('contact%d' % i)
            c['tel'] = TelNumber('9877')
    
    def create(self, name = None):
        name = name or self.new_name()
        contact = Contact(tichy.Text(name))
        self[name] = contact
        return contact
        
    def new_name(self):
        name = 'new'
        i = 0
        while name in self:
            name = "new%d" % i
            i += 1
        return name
        
    def remove(self, contact):
        for k,v in self.items():
            if v is contact:
                self.pop(k)
                
#class SelectContactService(Service):
#    service = 'SelectContact'
#    def select(self, window):
#        yield NotImplementedError
