#    Tichy
#    copyright 2008 Guillaume Chereau (charlie@openmoko.org)
#
#    This file is part of Tichy.
#
#    Tichy is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Tichy is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Tichy.  If not, see <http://www.gnu.org/licenses/>.

from widget import Widget
from geo import Vect

class ImageWidget(Widget):
    def __init__(self, parent, image, **kargs):
        self.image = image
        super(ImageWidget, self).__init__(parent, optimal_size = image.size, min_size = image.size, **kargs)
    def draw(self, painter):
        self.image.load(painter)
        painter.draw_surface(self.image.surf)

class Image(object):
    def __init__(self, path, size = None):
        self.path = path
        self.surf = None
        self.size = size
        
    def __repr__(self):
        return "Image(%s)" % self.path
        
    def load(self, painter):
        if self.surf:
            return
        self.surf = painter.surface_from_image(self.path)
        
    def view(self, parent):
        return ImageWidget(parent, self)
        
    def draw(self, painter):
        self.load(painter)
        painter.draw_surface(self.surf)

        
