#    Tichy
#    copyright 2008 Guillaume Chereau (charlie@openmoko.org)
#
#    This file is part of Tichy.
#
#    Tichy is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Tichy is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Tichy.  If not, see <http://www.gnu.org/licenses/>.

from tichy.tasklet import Tasklet, Wait
import tichy.application
from window import Window
from widget import Widget
from frame import Frame
from box import Box, AbsBox
from label import Label
from button import Button
from geo import Vect

class Message(tichy.application.Application):
    def run(self, parent, title):
        w = Window(parent)
        abox = AbsBox(w) # Because we want to be in the middle
        
        box = Frame(abox)
        box.pos = Vect(0,256)
        box.size = Vect(480, 192)
        
        frame = self.view(box, title = title)

        b = Button(frame)
        Label(b, 'OK')
        yield Wait(b, 'clicked')
        w.close()
