
from .item import Item
from .service import Service

class List(list, Item):
    def __init__(self, values = []):
        list.__init__(self, values)
        Item.__init__(self)
        assert hasattr(self, '_Object__listeners'), self
        
    def clear(self):
        self[:] = []
        self.emit('cleared')
        self.emit('modified')
        
    def append(self, value):
        list.append(self, value)
        self.emit('appened', value)
        self.emit('modified')
        
    def remove(self, value):
        list.remove(self, value)
        self.emit('removed', value)
        self.emit('modified')
        
    def view(self, parent, **kargs):
        design = Service('Design')
        return design.view_list(parent, self, **kargs)
        
    def on_appened(self, value, view):
        value.view(view)
        
    def on_removed(self, value, view):
        for c in view.children[:]:
            c.destroy()
        for item in self:
            item.view(view)
        
    def on_clear(self, view):
        for c in view.children[:]:
            c.destroy()
        
class ActorList(List):
    def view(self, parent, **kargs):
        design = Service('Design')
        return design.view_actor_list(parent, self, **kargs)
        
