#!/usr/bin/env python

#    Tichy
#    copyright 2008 Michael "Goodwill" openmoko /a/ webhippo.org
#
#    This file is part of Tichy.
#
#    Tichy is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Tichy is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Tichy.  If not, see <http://www.gnu.org/licenses/>.



import gobject
import time

from ..service import Service
from ..object import Object

import logging
logger = logging.getLogger('TimeService')

class TimeService(Service):
    """Time Service Class
    
    signals:
    * time-changed
    
    """
    
    service = 'Time'
    
    def __init__(self):
        super(TimeService, self).__init__()
        self.running = True
        self.event_id = gobject.timeout_add_seconds(1, self.time_changed)  

    def time_changed(self):
        self.emit('time-changed', time.time())
        return self.running
    
    # do we need stop?
    def stop(self):
        gobject.source_remove(self.event_id)
        self.running = False
        

        
